Después de completar los pasos que se indican en Prepárate para usar la API de People, podrás leer, copiar y buscar datos de "Otros contactos".
En las siguientes muestras de código, se explica cómo enviar algunas solicitudes simples. Para obtener una lista completa de métodos, consulta la documentación de referencia.
Enumera los "Otros contactos" del usuario
Para obtener una lista de las personas que se encuentran en "Otros contactos" del usuario, usa el siguiente código:
Protocolo
GET /v1/otherContacts?readMask=names,emailAddresses HTTP/1.1 Host: people.googleapis.com
Java
ListOtherContactsResponse response = peopleService.otherContacts().list() .setReadMask("metadata,names,emailAddresses") .execute(); List<Person> otherContacts = response.getOtherContacts();
Enumera los "Otros contactos" del usuario que cambiaron
Java
// Initial request ListOtherContactsResponse fullSyncResponse = peopleService.otherContacts().list() .setReadMask("metadata,names,emailAddresses") .setRequestSyncToken(true) .execute(); // Fetch all the pages while (fullSyncResponse.getNextPageToken() != null) { fullSyncResponse = peopleService.otherContacts().list() .setReadMask("metadata,names,emailAddresses") .setRequestSyncToken(true) .setPageToken(fullSyncResponse.getNextPageToken()) .execute(); } // Some time passes // Fetch incremental changes using the sync token returned in the last fullSyncResponse. try { ListOtherContactsResponse incrementalSyncResponse = peopleService.otherContacts().list() .setReadMask("metadata,names,emailAddresses") .setSyncToken(fullSyncResponse.getNextSyncToken()) .execute(); for (Person person : incrementalSyncResponse.getOtherContacts()) { handlePerson(person); } // Fetch all the pages while (!incrementalSyncResponse.getNextPageToken().isEmpty()) { incrementalSyncResponse = peopleService.otherContacts().list() .setReadMask("metadata,names,emailAddresses") .setSyncToken(fullSyncResponse.getNextSyncToken()) .setPageToken(incrementalSyncResponse.getNextPageToken()) .execute(); for (Person person : incrementalSyncResponse.getOtherContacts()) { handlePerson(person); } } } catch (GoogleJsonResponseException e) { if (e.getStatusCode() == 410) { // Sync token expired. Make full sync request. } } void handlePerson(Person person) { if (person.getMetadata().getDeleted()) { // Handle deleted person } else { // Handle changed person } }
Obtén más detalles sobre el comportamiento de la sincronización en ListOtherContacts.
Cómo copiar un contacto de "Otros contactos" al grupo "Mis contactos"
Para copiar un "Otro contacto" al grupo "myContacts", usa el siguiente código:
Protocolo
POST /v1/resource_name:copyOtherContactToMyContactsGroup?copyMask=names,emailAddresses,phoneNumbers HTTP/1.1 Host: people.googleapis.com
Java
Person copiedContact = peopleService .otherContacts() .copyOtherContactToMyContactsGroup( "resource_name", new CopyOtherContactToMyContactsGroupRequest() .setCopyMask("names,emailAddresses,phoneNumbers")) .execute();
Busca en "Otros contactos" del usuario
Para buscar en todos los "Otros contactos" del usuario, usa el siguiente código:
Protocolo
// Warmup cache GET /v1/otherContacts:search?query=&readMask=names,emailAddresses HTTP/1.1 Host: people.googleapis.com // Send search request after several seconds GET /v1/otherContacts:search?query=query&readMask=names,emailAddresses HTTP/1.1 Host: people.googleapis.com
Java
// Warmup cache SearchResponse response = peopleService.otherContacts().search() .setQuery("") .setReadMask("names,emailAddresses") .execute(); // Wait a few seconds Thread.sleep(5); // Send search request SearchResponse response = peopleService.otherContacts().search() .setQuery("query") .setReadMask("names,emailAddresses") .execute();